// Generated by CoffeeScript 1.10.0
(function() {
  var QedaElement, QedaPattern, QedaSymbol,
    slice = [].slice;

  QedaSymbol = require('./qeda-symbol');

  QedaPattern = require('./qeda-pattern');

  QedaElement = (function() {
    function QedaElement(library, definition) {
      var alias, i, j, key, l, last, len, len1, len2, m, name, o, p, part, pinName, pinNumber, pinNumbers, q, ref, ref1, ref2, ref3, ref4, ref5, ref6, suffix, value;
      this.library = library;
      this.mergeObjects(this, definition);
      if ((this.alias != null) && (!Array.isArray(this.alias))) {
        this.alias = [this.alias];
      }
      if (this.suffix != null) {
        if (this.alias == null) {
          this.alias = [];
        }
        if (!Array.isArray(this.suffix)) {
          this.suffix = [this.suffix];
        }
        ref = this.suffix;
        for (l = 0, len = ref.length; l < len; l++) {
          suffix = ref[l];
          alias = this.name + suffix;
          if (this.alias.indexOf(alias) === -1) {
            this.alias.push(alias);
          }
        }
      }
      this.longestAlias = this.name;
      if (this.alias != null) {
        ref1 = this.alias;
        for (m = 0, len1 = ref1.length; m < len1; m++) {
          alias = ref1[m];
          if (alias.length > this.longestAlias.length) {
            this.longestAlias = alias;
          }
        }
      }
      this.refDes = 'REF';
      this.symbols = [];
      this.pattern = new QedaPattern(this);
      this.pins = [];
      this.pinGroups = [];
      this._letters = ['', 'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H', 'J', 'K', 'L', 'M', 'N', 'P', 'R', 'T', 'U', 'V', 'W', 'Y'];
      last = this._letters.length - 1;
      for (i = o = 1, ref2 = last; 1 <= ref2 ? o <= ref2 : o >= ref2; i = 1 <= ref2 ? ++o : --o) {
        for (j = p = ref3 = i, ref4 = last; ref3 <= ref4 ? p <= ref4 : p >= ref4; j = ref3 <= ref4 ? ++p : --p) {
          this._letters.push(this._letters[i] + this._letters[j]);
        }
      }
      for (pinName in this.pinout) {
        pinNumbers = this._pinNumbers(this.pinout[pinName]);
        this.pinGroups[pinName] = pinNumbers;
        for (q = 0, len2 = pinNumbers.length; q < len2; q++) {
          pinNumber = pinNumbers[q];
          if (this.pins[pinNumber] == null) {
            this.pins[pinNumber] = this._pinObj(pinNumber, pinName);
          } else {
            this.pins[pinNumber].name += '/' + pinName;
          }
        }
      }
      ref5 = this.groups;
      for (key in ref5) {
        value = ref5[key];
        this.pinGroups[key] = this._concatenateGroups(value);
      }
      if (this.parts != null) {
        ref6 = this.parts;
        for (name in ref6) {
          part = ref6[name];
          this.symbols.push(new QedaSymbol(this, name, part));
        }
      } else {
        part = [];
        if (this.groups != null) {
          for (key in this.groups) {
            part.push(key);
          }
        } else {
          for (key in this.pinout) {
            part.push(key);
          }
        }
        this.symbols.push(new QedaSymbol(this, this.name, part));
      }
    }

    QedaElement.prototype.isFloat = function(n) {
      return Number(n) && (n % 1 !== 0);
    };

    QedaElement.prototype.mergeObjects = function(dest, src) {
      var k, results, v;
      results = [];
      for (k in src) {
        v = src[k];
        if (typeof v === 'object' && (!Array.isArray(v)) && dest.hasOwnProperty(k)) {
          results.push(this.mergeObjects(dest[k], v));
        } else {
          results.push(dest[k] = v);
        }
      }
      return results;
    };

    QedaElement.prototype.render = function() {
      var base, cap, def, handler, l, len, len1, m, outline, ref, ref1, ref2, ref3, symbol;
      if (this._rendered == null) {
        this._rendered = false;
      }
      if (this._rendered) {
        return;
      }
      handler = require("./element/" + this.library.elementStyle);
      handler(this);
      ref = this.symbols;
      for (l = 0, len = ref.length; l < len; l++) {
        symbol = ref[l];
        if (((ref1 = this.schematic) != null ? ref1.symbol : void 0) != null) {
          handler = require("./symbol/" + this.library.symbolStyle + "/" + (this.schematic.symbol.toLowerCase()));
          handler(symbol);
        }
      }
      if (((ref2 = this.housing) != null ? ref2.outline : void 0) != null) {
        outline = this.housing.outline;
        ref3 = this.library.outlineDefs;
        for (m = 0, len1 = ref3.length; m < len1; m++) {
          def = ref3[m];
          cap = def.regexp.exec(outline);
          if (cap) {
            handler = require("./outline/" + def.handler);
            handler.apply(null, [this.housing].concat(slice.call(cap.slice(1))));
          }
        }
      }
      this._convertDimensions(this.housing);
      handler = require("./pattern/" + this.library.patternStyle + "/" + this.pattern.handler);
      handler(this.pattern, this.housing);
      if ((base = this.pattern).name == null) {
        base.name = this.housing.pattern;
      }
      return this._rendered = true;
    };

    QedaElement.prototype._concatenateGroups = function(groups) {
      var group, l, len, pinGroup, result;
      result = [];
      if (!Array.isArray(groups)) {
        groups = [groups];
      }
      for (l = 0, len = groups.length; l < len; l++) {
        group = groups[l];
        pinGroup = this.pinGroups[group];
        if (pinGroup != null) {
          result = result.concat(pinGroup);
        }
      }
      return result;
    };

    QedaElement.prototype._convertDimensions = function(housing) {
      var key, max, min, nom, results, tol, value;
      results = [];
      for (key in housing) {
        value = housing[key];
        if (Array.isArray(value) && value.length > 0) {
          min = value[0];
          max = value.length > 1 ? value[1] : min;
          nom = (max + min) / 2;
          tol = max - min;
          results.push(housing[key] = {
            min: min,
            max: max,
            nom: nom,
            tol: tol
          });
        } else {
          results.push(void 0);
        }
      }
      return results;
    };

    QedaElement.prototype._pinNumbers = function(inputs) {
      var cap, i, input, j, l, len, len1, m, numbers, o, p, ref, ref1, ref2, ref3, sub, subs;
      numbers = [];
      if (!Array.isArray(inputs)) {
        inputs = [inputs];
      }
      for (l = 0, len = inputs.length; l < len; l++) {
        input = inputs[l];
        if (typeof input === 'number') {
          numbers.push(input.toString());
        } else if (typeof input === 'string') {
          input = input.replace(/\s+/g, '');
          subs = input.split(',');
          for (m = 0, len1 = subs.length; m < len1; m++) {
            sub = subs[m];
            cap = /([A-Z]*)(\d+)\.{2,3}([A-Z]*)(\d+)/.exec(sub);
            if (!cap) {
              numbers.push(sub);
            } else {
              for (i = o = ref = this._letters.indexOf(cap[1]), ref1 = this._letters.indexOf(cap[3]); ref <= ref1 ? o <= ref1 : o >= ref1; i = ref <= ref1 ? ++o : --o) {
                for (j = p = ref2 = cap[2], ref3 = cap[4]; ref2 <= ref3 ? p <= ref3 : p >= ref3; j = ref2 <= ref3 ? ++p : --p) {
                  numbers.push(this._letters[i] + j);
                }
              }
            }
          }
        }
      }
      return numbers;
    };

    QedaElement.prototype._pinObj = function(number, name) {
      var l, len, obj, pins, prop, props;
      obj = {
        name: name,
        number: number
      };
      if (this.properties != null) {
        props = ['bidir', 'ground', 'in', 'inverted', 'out', 'passive', 'power'];
        for (l = 0, len = props.length; l < len; l++) {
          prop = props[l];
          if (this.properties[prop] != null) {
            pins = Array.isArray(this.properties[prop]) ? this.properties[prop] : [this.properties[prop]];
            obj[prop] = pins.indexOf(name) !== -1;
          }
        }
      }
      return obj;
    };

    return QedaElement;

  })();

  module.exports = QedaElement;

}).call(this);
